//
// Atlantis - tile laying fun for the whole family!
// https://github.com/threerings/atlantis

package atlantis.shared;

import com.threerings.nexus.io.AbstractSerializer;

/**
 * A giant map of serializable classes. Some day this will be autogenerated.
 */
public class AtlantisSerializer extends AbstractSerializer
{
    public AtlantisSerializer () {
        mapStreamer(new Streamer_GameObject());
        mapStreamer(new Streamer_GameObject.Score());
        mapStreamer(new Streamer_GameTile());
        mapStreamer(new Streamer_Location());
        mapStreamer(new Streamer_MatchObject());
        mapStreamer(new Streamer_MatchService.GameInfo());
        mapStreamer(new Streamer_Piecen());
        mapStreamer(new Streamer_Placement());

        mapEnumStreamer(Edge.class);
        mapEnumStreamer(Feature.Type.class);
        mapEnumStreamer(GameObject.State.class);
        mapEnumStreamer(Orient.class);
        mapEnumStreamer(Terrain.class);

        mapService(new Factory_GameService(), GameService.class);
        mapService(new Factory_MatchService(), MatchService.class);
    }
}
